Index: java/Postak/src/cz/frantovo/postak/Nastaveni.java
===================================================================
--- java/Postak/src/cz/frantovo/postak/Nastaveni.java	(revision 4:dfb345ef9452)
+++ java/Postak/src/cz/frantovo/postak/Nastaveni.java	(revision 5:bea5d9e11d37)
@@ -9,103 +9,115 @@
  */
 public class Nastaveni implements Serializable {
-    private static final long serialVersionUID = -3155540704924123097L;
-    
-    private String postovniServer = "localhost";
-    private int postovniPort = 25;
-    private String postovniJmeno;
-    private char[] postovniHeslo;
-    private int limitZprav = 1000;
-    
-    /** Připojovací řetězec */
-    private String databaze;
-    private String dbJmeno;
-    private char[] dbHeslo;
-    
-    /** Výchozí příjemci */
-    private ArrayList<InternetAddressKomu> vychoziPrijemci;
-    
-    /** Přejatá konstanta od SuperPošťáka */
-    private String cestaKCertifikatum;
 
-    public String getCestaKCertifikatum() {
-        return cestaKCertifikatum;
-    }
+	private static final long serialVersionUID = -3155540704924123097L;
+	private String postovniServer = "localhost";
+	private int postovniPort = 25;
+	private String postovniJmeno;
+	private char[] postovniHeslo;
+	private int limitZprav = 1000;
+	/** Připojovací řetězec */
+	private String databaze;
+	private String dbJmeno;
+	private char[] dbHeslo;
+	/** Výchozí příjemci */
+	private ArrayList<InternetAddressKomu> vychoziPrijemci;
+	/** Přejatá konstanta od SuperPošťáka */
+	private String cestaKCertifikatum;
+	/** 
+	 * Výchozí adresář pro ukládání a načítání souborů
+	 * např. pro souborové dialogy
+	 */
+	private String pracovniAdresar;
 
-    public void setCestaKCertifikatum(String cestaKCertifikatum) {
-        this.cestaKCertifikatum = cestaKCertifikatum;
-    }
+	public String getPracovniAdresar() {
+		if (pracovniAdresar == null) {
+			return System.getProperty("user.home");
+		} else {
+			return pracovniAdresar;
+		}
+	}
 
-    public String getPostovniServer() {
-        return postovniServer;
-    }
+	public void setPracovniAdresar(String pracovniAdresar) {
+		this.pracovniAdresar = pracovniAdresar;
+	}
 
-    public void setPostovniServer(String postovniServer) {
-        this.postovniServer = postovniServer;
-    }
+	public String getCestaKCertifikatum() {
+		return cestaKCertifikatum;
+	}
 
-    public int getPostovniPort() {
-        return postovniPort;
-    }
+	public void setCestaKCertifikatum(String cestaKCertifikatum) {
+		this.cestaKCertifikatum = cestaKCertifikatum;
+	}
 
-    public void setPostovniPort(int postovniPort) {
-        this.postovniPort = postovniPort;
-    }
+	public String getPostovniServer() {
+		return postovniServer;
+	}
 
-    public String getPostovniJmeno() {
-        return postovniJmeno;
-    }
+	public void setPostovniServer(String postovniServer) {
+		this.postovniServer = postovniServer;
+	}
 
-    public void setPostovniJmeno(String postovniJmeno) {
-        this.postovniJmeno = postovniJmeno;
-    }
+	public int getPostovniPort() {
+		return postovniPort;
+	}
 
-    public char[] getPostovniHeslo() {
-        return postovniHeslo;
-    }
+	public void setPostovniPort(int postovniPort) {
+		this.postovniPort = postovniPort;
+	}
 
-    public void setPostovniHeslo(char[] postovniHeslo) {
-        this.postovniHeslo = postovniHeslo;
-    }
+	public String getPostovniJmeno() {
+		return postovniJmeno;
+	}
 
-    public int getLimitZprav() {
-        return limitZprav;
-    }
+	public void setPostovniJmeno(String postovniJmeno) {
+		this.postovniJmeno = postovniJmeno;
+	}
 
-    public void setLimitZprav(int limitZprav) {
-        this.limitZprav = limitZprav;
-    }
+	public char[] getPostovniHeslo() {
+		return postovniHeslo;
+	}
 
-    public String getDatabaze() {
-        return databaze;
-    }
+	public void setPostovniHeslo(char[] postovniHeslo) {
+		this.postovniHeslo = postovniHeslo;
+	}
 
-    public String getDbJmeno() {
-        return dbJmeno;
-    }
+	public int getLimitZprav() {
+		return limitZprav;
+	}
 
-    public char[] getDbHeslo() {
-        return dbHeslo;
-    }
+	public void setLimitZprav(int limitZprav) {
+		this.limitZprav = limitZprav;
+	}
 
-    public ArrayList<InternetAddressKomu> getVychoziPrijemci() {
-        return vychoziPrijemci;
-    }
+	public String getDatabaze() {
+		return databaze;
+	}
 
-    public void setDatabaze(String databaze) {
-        this.databaze = databaze;
-    }
+	public String getDbJmeno() {
+		return dbJmeno;
+	}
 
-    public void setDbJmeno(String dbJmeno) {
-        this.dbJmeno = dbJmeno;
-    }
+	public char[] getDbHeslo() {
+		return dbHeslo;
+	}
 
-    public void setDbHeslo(char[] dbHeslo) {
-        this.dbHeslo = dbHeslo;
-    }
+	public ArrayList<InternetAddressKomu> getVychoziPrijemci() {
+		return vychoziPrijemci;
+	}
 
-    public void setVychoziPrijemci(ArrayList<InternetAddressKomu> vychoziPrijemci) {
-        this.vychoziPrijemci = vychoziPrijemci;
-    }
-    
+	public void setDatabaze(String databaze) {
+		this.databaze = databaze;
+	}
 
+	public void setDbJmeno(String dbJmeno) {
+		this.dbJmeno = dbJmeno;
+	}
+
+	public void setDbHeslo(char[] dbHeslo) {
+		this.dbHeslo = dbHeslo;
+	}
+
+	public void setVychoziPrijemci(ArrayList<InternetAddressKomu> vychoziPrijemci) {
+		this.vychoziPrijemci = vychoziPrijemci;
+	}
 }