Index: java/SuperPostak/src/cz/frantovo/superPostak/SuperPostak.java
===================================================================
--- java/SuperPostak/src/cz/frantovo/superPostak/SuperPostak.java	(revision 15:9175a185d9c0)
+++ java/SuperPostak/src/cz/frantovo/superPostak/SuperPostak.java	(revision 17:9cb46ca7e26c)
@@ -10,4 +10,6 @@
 import java.awt.Dialog.ModalityType;
 import java.awt.KeyboardFocusManager;
+import java.awt.event.ActionListener;
+import java.awt.event.ItemListener;
 import java.beans.XMLDecoder;
 import java.beans.XMLEncoder;
@@ -29,10 +31,6 @@
 import javax.mail.MessagingException;
 import javax.mail.internet.InternetAddress;
-import javax.swing.JComponent;
-import javax.swing.JDialog;
-import javax.swing.JOptionPane;
-import javax.swing.JTextArea;
-import javax.swing.UIManager;
-import javax.swing.UnsupportedLookAndFeelException;
+import javax.swing.*;
+import javax.swing.event.ChangeListener;
 import org.jdesktop.swingx.JXErrorPane;
 import org.jdesktop.swingx.JXTaskPaneContainer;
@@ -41,5 +39,5 @@
 /**
  *
- * @author  fiki
+ * @author fiki
  */
 public class SuperPostak extends javax.swing.JFrame {
@@ -57,4 +55,5 @@
 	/**
 	 * Creates new form SuperPostak
+	 *
 	 * @param ladit předvyplní testovací hodnoty - zprávu
 	 * @param exit při zavření okna ukončí program
@@ -351,6 +350,8 @@
         vstupZprava = new javax.swing.JTextArea();
         jLabel15 = new javax.swing.JLabel();
-        vstupFormatHTML = new javax.swing.JCheckBox();
         odpovedetKomuOdkaz = new org.jdesktop.swingx.JXHyperlink();
+        formátProstý = new javax.swing.JRadioButton();
+        formátXHTML = new javax.swing.JRadioButton();
+        formátOboje = new javax.swing.JRadioButton();
         odpovedetKomuDialog = new javax.swing.JDialog();
         jLabel18 = new javax.swing.JLabel();
@@ -360,4 +361,5 @@
         odpovedetKomuAdresa = new javax.swing.JTextField();
         odpovedetKomuHotovo = new javax.swing.JButton();
+        formátSkupina = new javax.swing.ButtonGroup();
         jXHeader1 = new org.jdesktop.swingx.JXHeader();
         taskPanel = new org.jdesktop.swingx.JXTaskPaneContainer();
@@ -701,8 +703,4 @@
         jLabel15.setText("Formát zprávy");
 
-        vstupFormatHTML.setMnemonic('h');
-        vstupFormatHTML.setText("HTML");
-        vstupFormatHTML.setToolTipText("Při nezaškrtnutí se odešle jako prostý text");
-
         odpovedetKomuOdkaz.setForeground(javax.swing.UIManager.getDefaults().getColor("windowText"));
         odpovedetKomuOdkaz.setMnemonic('e');
@@ -717,4 +715,24 @@
         });
 
+        formátSkupina.add(formátProstý);
+        formátProstý.setSelected(true);
+        formátProstý.setText("Prostý text");
+
+        formátSkupina.add(formátXHTML);
+        formátXHTML.setText("(X)HTML");
+        formátXHTML.addActionListener(new java.awt.event.ActionListener() {
+            public void actionPerformed(java.awt.event.ActionEvent evt) {
+                formátXHTMLActionPerformed(evt);
+            }
+        });
+
+        formátSkupina.add(formátOboje);
+        formátOboje.setText("Oboje");
+        formátOboje.addActionListener(new java.awt.event.ActionListener() {
+            public void actionPerformed(java.awt.event.ActionEvent evt) {
+                formátObojeActionPerformed(evt);
+            }
+        });
+
         javax.swing.GroupLayout panelZpravaLayout = new javax.swing.GroupLayout(panelZprava);
         panelZprava.setLayout(panelZpravaLayout);
@@ -723,7 +741,7 @@
             .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelZpravaLayout.createSequentialGroup()
                 .addContainerGap()
-                .addGroup(panelZpravaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
-                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 438, Short.MAX_VALUE)
-                    .addGroup(panelZpravaLayout.createSequentialGroup()
+                .addGroup(panelZpravaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
+                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 461, Short.MAX_VALUE)
+                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelZpravaLayout.createSequentialGroup()
                         .addGroup(panelZpravaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                             .addGroup(panelZpravaLayout.createSequentialGroup()
@@ -736,12 +754,16 @@
                                 .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)))
                         .addGroup(panelZpravaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
-                            .addComponent(vstupJmenoOdesilatele, javax.swing.GroupLayout.DEFAULT_SIZE, 328, Short.MAX_VALUE)
-                            .addComponent(vstupAdresaOdesilatele, javax.swing.GroupLayout.DEFAULT_SIZE, 328, Short.MAX_VALUE)
-                            .addComponent(vstupPredmet, javax.swing.GroupLayout.DEFAULT_SIZE, 328, Short.MAX_VALUE)))
-                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, panelZpravaLayout.createSequentialGroup()
+                            .addComponent(vstupJmenoOdesilatele)
+                            .addComponent(vstupAdresaOdesilatele)
+                            .addComponent(vstupPredmet)))
+                    .addGroup(panelZpravaLayout.createSequentialGroup()
                         .addComponent(jLabel15)
-                        .addGap(33, 33, 33)
-                        .addComponent(vstupFormatHTML, javax.swing.GroupLayout.DEFAULT_SIZE, 81, Short.MAX_VALUE)
-                        .addGap(247, 247, 247)))
+                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
+                        .addComponent(formátProstý)
+                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
+                        .addComponent(formátXHTML)
+                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
+                        .addComponent(formátOboje)
+                        .addGap(0, 0, Short.MAX_VALUE)))
                 .addContainerGap())
         );
@@ -766,5 +788,7 @@
                 .addGroup(panelZpravaLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                     .addComponent(jLabel15)
-                    .addComponent(vstupFormatHTML))
+                    .addComponent(formátProstý)
+                    .addComponent(formátXHTML)
+                    .addComponent(formátOboje))
                 .addContainerGap())
         );
@@ -817,5 +841,5 @@
                     .addComponent(odpovedetKomuAdresa, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                 .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
-                .addComponent(jLabel17)
+                .addComponent(jLabel17, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                 .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                 .addComponent(odpovedetKomuHotovo)
@@ -967,5 +991,15 @@
 		zprava.setPredmet(vstupPredmet.getText());
 		zprava.setText(vstupZprava.getText());
-		zprava.setFormatHTML(vstupFormatHTML.isSelected());
+
+		if (formátProstý.isSelected()) {
+			zprava.setFormatHTML(HromadnaZprava.FORMÁT.PROSTÝ_TEXT);
+		} else if (formátXHTML.isSelected()) {
+			zprava.setFormatHTML(HromadnaZprava.FORMÁT.XHTML);
+		} else if (formátOboje.isSelected()) {
+			zprava.setFormatHTML(HromadnaZprava.FORMÁT.OBOJE);
+		} else {
+			log.severe("Není zvolen formát zprávy → nastavuji: prostý text.");
+			zprava.setFormatHTML(HromadnaZprava.FORMÁT.PROSTÝ_TEXT);
+		}
 
 		if (Postak.zkontrolujAdresu(odpovedetKomuAdresa.getText())) {
@@ -1103,4 +1137,26 @@
 }//GEN-LAST:event_odpovedetKomuHotovoActionPerformed
 
+	private void formátXHTMLActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_formátXHTMLActionPerformed
+		nastavVýchozíXHTML();
+	}//GEN-LAST:event_formátXHTMLActionPerformed
+
+	private void formátObojeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_formátObojeActionPerformed
+		nastavVýchozíXHTML();
+	}//GEN-LAST:event_formátObojeActionPerformed
+
+	/**
+	 * Pokud ještě není vyplněn žádný text, vložíme šablonu.
+	 */
+	private void nastavVýchozíXHTML() {
+		if (vstupZprava.getText().isEmpty()) {
+			vstupZprava.setText("<html xmlns=\"http://www.w3.org/1999/xhtml\">\n"
+					+ "<body>\n\n"
+					+ "<p></p>\n"
+					+ "<div class=\"patička\"></div>\n\n"
+					+ "</body>\n"
+					+ "</html>");
+		}
+	}
+
 	/** Provede uživatelem zadaný SQL dotaz a vrátí získané příjemce */
 	private Collection<InternetAddressKomu> getPrijemciSQL() throws SQLException, UnsupportedEncodingException {
@@ -1184,4 +1240,8 @@
 	}
     // Variables declaration - do not modify//GEN-BEGIN:variables
+    private javax.swing.JRadioButton formátOboje;
+    private javax.swing.JRadioButton formátProstý;
+    private javax.swing.ButtonGroup formátSkupina;
+    private javax.swing.JRadioButton formátXHTML;
     private javax.swing.JLabel jLabel1;
     private javax.swing.JLabel jLabel10;
@@ -1240,5 +1300,4 @@
     private javax.swing.JTextField vstupDBjmeno;
     private javax.swing.JTextField vstupDatabaze;
-    private javax.swing.JCheckBox vstupFormatHTML;
     private javax.swing.JTextField vstupJmenoOdesilatele;
     private javax.swing.JTextField vstupPredmet;